// if you don't have a JQuery plugin, remove ./jquery.@@component_filename@@.js from the dependency array below
// if you need more than one, add extra filenames to the dependency array

define(["app", "./jquery.@@component_filename@@.js"], function (app) {
	app.ng.controller("av@@component_angularcode@@", ["$scope", "Form", "$element", "$timeout", "DynamicData", "$filter", function ($scope, Form, $element, $timeout, dynamicData, $filter) {
		Form.getItem($scope, $element).then(function (item) {

			let startValue = {};
			startValue[item.properties.animationProperty] = item.properties.startValue;

			let endValue = {};
			endValue[item.properties.animationProperty] = item.properties.endValue;

			function animateItems(ids) {
				$('.id-' + ids.join(',.id-'))
					.animate(endValue, item.properties.animationDuration)
					.animate(startValue, item.properties.animationDuration);
			}

			$scope.handleClick = function (item) {
				animateItems($scope.ids);
			};

			item.currency = function (value, decimals) {
				return $filter('currency')(value, undefined, decimals);
			};

			item.number = function (value, decimals) {
				return $filter('number')(value, decimals);
			};

			$timeout(function () {
				$(window).on('hashchange', function (e) {
					var hhhh = 0;
				});
				$(window).on('beforeunload', function (e) {
					var params = {};
					params.sfmServiceName = "All Subs";
					params.sfmOperationName = "dynamicData";
					params.sfmFormCode = dynamicData.config.formCode;
					if (dynamicData.config.requestKey) params.sfmRequestKey = dynamicData.config.requestKey;

					$.ajax({
						async: false,
						type: "POST",
						url: dynamicData.config.url,
						data: params,
						contentType: "application/x-www-form-urlencoded",
						dataType: "json",
						timeout: 60000,
						success: function (response) {
							var zzzz = response;
						},
						error: function (jq, status, message) {
							var eeee = message;
						}
					});
				});

				$scope.ids = item.properties.targets.map(function (r) {
					return Form.getUniqueId(r.ref.split(".").pop(), $scope.data);
				});

				animateItems($scope.ids);
			});
		});
	}]);
});
